#ifndef PW_SCRIPT_HPP
#define PW_SCRIPT_HPP

#include <lua.hpp>
#include <memory>


#include <pw/core/scripting.hpp>


namespace pw {


class script;

class main_loop {

    script &_s;
    bool _stop = false;

    main_loop(script& s);

};

class script {
protected:

    scripting::state _lua;

public:

    script();
    ~script();

    bool update();

    bool load(const std::string &s);

    int run(const std::string& s);

    void load(sol::table &ns);

    friend class main_loop;

};

}



#endif
